
import { useState,  useEffect } from 'react';

import Request, {YWRequestConfig} from '@ywfe/request';
// @ts-ignore
import * as querystring from 'querystring';
// @ts-ignore
import { ParsedUrlQueryInput } from 'querystring';
// @ts-ignore
import * as R from 'ramda';
import {configs} from './config';


  const projectId = "PROAUTH";
  let env;
  if(typeof window === 'undefined'){
    env = (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  } else {
    env = window.localStorage.getItem('env') || (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  }
  
  const basePath = configs[projectId] ? configs[projectId][env].API_BASE_URL + `${env === 'mock' ? '/' + 88 : ''}` : '';
  const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
  

  

// @ts-ignore




export interface DesktopHomeCommonFunctionSortInput {
  
    
    /** 排序资源 ,String */
    resourceIdList?: any[];
  
}

export interface DesktopHomeCommonFunctionSortData {
  
}


const reduceParams = (data: R.Dictionary<DesktopHomeCommonFunctionSortInput>) => {
  if(data instanceof FormData){
    return data;
  }
  const result = R.filter(item => !R.isNil(item) && !R.isEmpty(item))(data) || {};
  return result as unknown as DesktopHomeCommonFunctionSortInput;
}


// 20968 重排序常用功能

  export const usePostDesktopHomeCommonFunctionSort = () => {
    let isMount = true;
    const [isDesktopHomeCommonFunctionSortLoading, setIsDesktopHomeCommonFunctionSortLoading] = useState(false);
    const [dataDesktopHomeCommonFunctionSort, setDataDesktopHomeCommonFunctionSort] = useState<DesktopHomeCommonFunctionSortData>({} as DesktopHomeCommonFunctionSortData);
    const postDesktopHomeCommonFunctionSortData = async(inputs: DesktopHomeCommonFunctionSortInput, config?: YWRequestConfig): Promise<DesktopHomeCommonFunctionSortData> => {
      
        const params = reduceParams(inputs as unknown as R.Dictionary<DesktopHomeCommonFunctionSortInput>) || {};
      
      if(isMount){
        setIsDesktopHomeCommonFunctionSortLoading(true);
      }
      
      try{
        
          
          
          const res: any = await Request.post<DesktopHomeCommonFunctionSortData>(`${basePath}/desktop/home/common/function/sort`, params, {
            loginHost: loginPath,
            ...config
          });
          
          
          if(isMount){
            setDataDesktopHomeCommonFunctionSort(res || {});
            setIsDesktopHomeCommonFunctionSortLoading(false);
          }
          return res;
      } catch(error){
        console.log(error);
        if(isMount){
          setIsDesktopHomeCommonFunctionSortLoading(false);
        }
        return false as unknown as DesktopHomeCommonFunctionSortData;
      }
      
    }

    useEffect(() => {
      return () => {
        isMount = false;
      };
    }, []);
  
    return {
      isDesktopHomeCommonFunctionSortLoading,
      dataDesktopHomeCommonFunctionSort,
      postDesktopHomeCommonFunctionSortData,
    }
  }

